﻿Type=Class
Version=2.5
@EndOfDesignText@
'version: 1.02

'2 problems.  large list items lags with clear/replace continuously polling.  also, long click not working well with continous replacing

Sub Class_Globals
	Private sv As ScrollView
	Private items As List
	Private panels As List
	Private dividerHeight As Float
	Private pressedDrawable As Object
	Private EventName As String
	Private CallBack As Object
	Private su As StringUtils
	
	Public DefaultTextSize, DefaultTextSize2 As Int
	Public DefaultTextColor, DefaultTextColor2 As Int
	Public DefaultTextBackgroundColor As Int
	Public Tag As String
	Public Visible As Boolean
	
	Private BitmapSize As Int
	Private h1, h2 As Int			'used in conjunction with BitmapSize
	Dim r As Reflector

End Sub


Public Sub Initialize (vCallback As Object, vEventName As String)
	sv.Initialize2(0, "sv")
	
	items.Initialize
	panels.Initialize
		
	EventName = vEventName
	CallBack = vCallback

    r.Target = r.GetContext
    r.Target = r.RunMethod("getResources")
	Dim idPressed As Int
   	idPressed = r.GetStaticField("android.R$drawable", "list_selector_background")
	pressedDrawable = r.RunMethod2("getDrawable", idPressed, "java.lang.int")
	
	sv.Color = 0xFFD9D7DE 'this sets the dividers color
	DefaultTextColor = Colors.White
	DefaultTextColor2 = Colors.Gray
	DefaultTextBackgroundColor = Colors.Black

	DefaultTextSize = 24
	DefaultTextSize2 = 18

	h1 = 22dip: h2 = 45dip
	BitmapSize = 40dip
	dividerHeight = 2dip
	
End Sub
' Resizes the given picture
Private Sub CreateScaledBitmap(Original As Bitmap, Width As Int, Height As Int) As Bitmap
	Dim r As Reflector
	Dim b As Bitmap
	b = r.RunStaticMethod("android.graphics.Bitmap", "createScaledBitmap", _
			Array As Object(Original, Width, Height, True), _
			Array As String("android.graphics.Bitmap", "java.lang.int", "java.lang.int", "java.lang.boolean"))
	Return b
End Sub

' Resizes the bitmap to fit the given dimensions
Public Sub AdjustBitmap(bmp As Bitmap, Width As Int, Height As Int) As Bitmap
	Dim RatioBmp, RatioIV As Float
	RatioBmp = bmp.Width / bmp.Height
	RatioIV = Width / Height
	Dim Diviseur As Float
	If RatioIV > RatioBmp Then
		Diviseur = bmp.Height / Height
		bmp = CreateScaledBitmap(bmp, Round(bmp.Width / Diviseur / Density), Round(Height / Density))
	Else
		Diviseur = bmp.Width / Width
		bmp = CreateScaledBitmap(bmp, Round(Width / Density), Round(bmp.Height / Diviseur / Density))
	End If
	Return bmp
End Sub

'Clears all items.
Public Sub Clear
	items.Clear
	panels.Clear
	sv.Panel.Height = 0
	For i = sv.Panel.NumberOfViews - 1 To 0 Step -1
		sv.Panel.RemoveViewAt(i)
	Next
End Sub

'Returns a view object that holds the list.
Public Sub AsView As View
	Return sv
End Sub

'Returns the number of items.
Public Sub GetSize As Int
	Return items.Size
End Sub

'Returns the Panel stored at the specified index.
Public Sub GetPanel(Index As Int) As Panel
	Dim p As Panel
	p = panels.Get(Index) 'this is the parent panel
	Return p.GetView(0)
End Sub

'Returns the value stored at the specified index.
Public Sub GetValue(Index As Int) As Object
	Return items.Get(Index)
End Sub

'Removes the item at the specified index.
Public Sub RemoveAt(Index As Int)
	Dim removePanel, p As Panel
	removePanel = panels.Get(Index)
	For i = Index + 1 To items.Size - 1
		p = panels.Get(i)
		p.Tag = i - 1
		p.Top = p.Top - removePanel.Height - dividerHeight
	Next
	sv.Panel.Height = sv.Panel.Height - removePanel.Height - dividerHeight
	items.RemoveAt(Index)
	panels.RemoveAt(Index)
	removePanel.RemoveView
End Sub

'Adds a text item. The item height will be adjusted based on the text.
Public Sub AddTextItem(Text As String, Text2 As String, Value As Object, Image As Bitmap)
	If items.Size > 0 Then RemoveAt(items.Size -1)
	InsertAtTextItem(items.Size, Text, Text2, Value, Image)
End Sub

'Inserts a text item at the specified index.
Public Sub InsertAtTextItem(Index As Int, Text As String, Text2 As String, Value As Object, Image As Bitmap)
	Dim pnl As Panel
	pnl.Initialize("")
	
	Dim lbl, lbl2 As Label
	lbl.Initialize("")
	lbl2.Initialize("")
	
	If Image.IsInitialized Then
		'image
		Dim iv As ImageView: iv.Initialize("")
		If NumberFormat(Image.Width / Image.Height, 1, 2) = NumberFormat(1, 1, 2) Then
			' Aspect ratio nearly equal -> filling
			iv.Gravity = Gravity.FILL
		Else
			' Different aspect ratio -> resizing
			Image = AdjustBitmap(Image, BitmapSize, BitmapSize)
			iv.Gravity = Gravity.CENTER_VERTICAL
		End If
		iv.Bitmap = Image
		pnl.AddView(iv, 0, 0, BitmapSize, BitmapSize)
	End If

	lbl.Gravity = Bit.OR(Gravity.CENTER_VERTICAL, Gravity.LEFT)
	lbl2.Gravity = Bit.OR(Gravity.CENTER_VERTICAL, Gravity.LEFT)
	
	
	Dim sType As Int
	If Text <> "" AND Text2 = "" Then sType = 1
	If Text = "" AND Text2 <> "" Then sType = 2
	If Text <> "" AND Text2 <> "" Then sType = 3
	
	
	'text1
	lbl.Text = Text
	lbl.TextSize = DefaultTextSize
	lbl.TextColor = DefaultTextColor
	
	'text2
	lbl2.Text = Text2
	lbl2.TextSize = DefaultTextSize2
	lbl2.TextColor = DefaultTextColor2
	
	Dim minHeight, minHeight2 As Int

	If Image.IsInitialized Then
		Select Case sType
			Case 1
				pnl.AddView(lbl, 45dip, dividerHeight, sv.Width - 5dip, h1)
			Case 2
				pnl.AddView(lbl2, 45dip, dividerHeight, sv.Width - 5dip, h1)
			Case 3
				pnl.AddView(lbl, 45dip, dividerHeight, sv.Width - 5dip, h1)
				minHeight = su.MeasureMultilineTextHeight(lbl, Text)	

				pnl.AddView(lbl2, 45dip, minHeight, sv.Width - 5dip, h1)
		End Select
	Else
		Select Case sType
			Case 1
				pnl.AddView(lbl, 5dip, dividerHeight, sv.Width - 5dip, h1)	
			Case 2
				pnl.AddView(lbl2, 5dip, dividerHeight, sv.Width - 5dip, h1)
			Case 3
				pnl.AddView(lbl, 5dip, dividerHeight, sv.Width - 5dip, h1)
				minHeight = su.MeasureMultilineTextHeight(lbl, Text)	

				pnl.AddView(lbl2, 5dip, minHeight, sv.Width - 5dip, h1)
		End Select
	End If
	
	pnl.Color = DefaultTextBackgroundColor
	
	If Text <> "" Then 
		minHeight = su.MeasureMultilineTextHeight(lbl, Text)
	End If
	
	If Text2 <> "" Then
		minHeight2 = su.MeasureMultilineTextHeight(lbl2, Text2)
	End If
	
	Select Case sType
		Case 1: lbl.Height = Max(h2, minHeight)
		Case 2: lbl2.Height = Max(h2, minHeight2)
		Case 3:
			lbl.Height = Max(h1, minHeight)
			lbl2.Height = Max(h1, minHeight2)
	End Select
	
	If Image.IsInitialized Then 
		Select Case sType
			Case 1: iv.Top = ((lbl.Height - iv.Height) + 6dip) /2
			Case 2: iv.Top = ((lbl2.Height - iv.Height) + 6dip) /2
			Case 3: iv.Top = ((lbl.Height + lbl2.Height) - iv.Height + 6dip) /2
		End Select
	End If
	
	Select Case sType 
		Case 1:	InsertAt(Index, pnl, lbl.Height + 5dip, 0, Value)
		Case 2: InsertAt(Index, pnl, 0, lbl2.Height + 5dip, Value)
		Case 3:InsertAt(Index, pnl, lbl.Height, lbl2.Height + 5dip, Value)
	End Select

End Sub
'Adds a custom item at the specified index.
Public Sub InsertAt(Index As Int, Pnl As Panel, ItemHeight As Int, ItemHeight2 As Int, Value As Object)
    
	Dim sd As StateListDrawable
    sd.Initialize
    sd.AddState(sd.State_Pressed, pressedDrawable)
    sd.AddCatchAllState(Pnl.Background)
	
	'create another panel to handle the click event
	Dim p As Panel
	p.Initialize("panel")
	p.Background = sd
	Dim cd As ColorDrawable
	cd.Initialize(Colors.Transparent, 0)
	
    Pnl.Background = cd
	p.AddView(Pnl, 0, 0, sv.Width, ItemHeight + ItemHeight2)
	p.Tag = Index
	
	If Index = items.Size Then
		items.Add(Value)
		panels.Add(p)
		Dim top As Int
		
		If Index = 0 Then 
			top = dividerHeight 
		Else 
			top = sv.Panel.Height
		End If
		
		sv.Panel.AddView(p, 0, top, sv.Width, ItemHeight + ItemHeight2)
	Else
		Dim top As Int
		If Index = 0 Then
			top = dividerHeight
		Else
			Dim previousPanel As Panel
			previousPanel = panels.Get(Index - 1)
			top = previousPanel.top + previousPanel.Height + dividerHeight
		End If

		Dim p2 As Panel
		For i = Index To panels.Size - 1
			p2 = panels.Get(i)
			p2.top = p2.top + ItemHeight + ItemHeight2 + dividerHeight
			p2.Tag = i + 1
		Next
		items.InsertAt(Index, Value)
		panels.InsertAt(Index, p)
		sv.Panel.AddView(p, 0, top, sv.Width, ItemHeight + ItemHeight2)
	End If
	
	sv.Panel.Height = sv.Panel.Height + ItemHeight + ItemHeight2 + dividerHeight
	If items.Size = 1 Then sv.Panel.Height = sv.Panel.Height + dividerHeight


	InsertMaskPanel(items.Size, "Mask")
End Sub
Private Sub InsertMaskPanel(Index As Int, Value As Object)
	Dim pnl As Panel
	pnl.Initialize("")
	
	Dim lbl As Label
	lbl.Initialize("")


	lbl.Gravity = Bit.OR(Gravity.CENTER_VERTICAL, Gravity.LEFT)
	
	
	Dim sType As Int: sType = 1
	

	Dim minHeight As Int


	Select Case sType
		Case 1
			pnl.AddView(lbl, 5dip, sv.Panel.Height + dividerHeight, sv.Width - 5dip, h1)	

	End Select
	
	pnl.Color = DefaultTextBackgroundColor
	
	Select Case sType
		Case 1
		If sv.Panel.Height > sv.Height Then
			lbl.Height = 1
		Else
			lbl.Height = sv.Height - sv.Panel.Height + dividerHeight
		End If
	End Select
	
	Select Case sType 
		Case 1:	InsertAtMask(Index, pnl, lbl.Height + 5dip, 0, Value)
	End Select
End Sub
'Adds a custom item at the specified index.
Public Sub InsertAtMask(Index As Int, Pnl As Panel, ItemHeight As Int, ItemHeight2 As Int, Value As Object)
    
	Dim sd As StateListDrawable
    sd.Initialize
    sd.AddState(sd.State_Pressed, pressedDrawable)
    sd.AddCatchAllState(Pnl.Background)
	
	'create another panel to handle the click event
	Dim p As Panel
	p.Initialize("panel")
	p.Background = sd
	Dim cd As ColorDrawable
	cd.Initialize(Colors.Transparent, 0)
	
    Pnl.Background = cd
	p.AddView(Pnl, 0, 0, sv.Width, ItemHeight + ItemHeight2)
	p.Tag = Index
	
	If Index = items.Size Then
		items.Add(Value)
		panels.Add(p)
		Dim top As Int
		
		If Index = 0 Then 
			top = dividerHeight 
		Else 
			top = sv.Panel.Height
		End If
		
		sv.Panel.AddView(p, 0, top, sv.Width, ItemHeight + ItemHeight2)
	Else
		Dim top As Int
		If Index = 0 Then
			top = dividerHeight
		Else
			Dim previousPanel As Panel
			previousPanel = panels.Get(Index - 1)
			top = previousPanel.top + previousPanel.Height + dividerHeight
		End If

		Dim p2 As Panel
		For i = Index To panels.Size - 1
			p2 = panels.Get(i)
			p2.top = p2.top + ItemHeight + ItemHeight2 + dividerHeight
			p2.Tag = i + 1
		Next
		items.InsertAt(Index, Value)
		panels.InsertAt(Index, p)
		sv.Panel.AddView(p, 0, top, sv.Width, ItemHeight + ItemHeight2)
	End If
	
	sv.Panel.Height = sv.Panel.Height + ItemHeight + ItemHeight2 + dividerHeight
	If items.Size = 1 Then sv.Panel.Height = sv.Panel.Height + dividerHeight
	
End Sub

'Adds a custom item.
Public Sub Add(Pnl As Panel, ItemHeight As Int,  ItemHeight2 As Int, Value As Object)
	InsertAt(items.Size, Pnl, ItemHeight, ItemHeight2, Value)
End Sub

'Scrolls the list to the specified item.
Public Sub JumpToItem(Index As Int)
	Dim top As Int
	Dim p As Panel
	For i = 0 To Min(Index - 1, items.Size - 1)
		p = panels.Get(i)
		top = top + p.Height + dividerHeight
	Next
	sv.ScrollPosition = top
	'The scroll position doesn't always gets updated without two calls to DoEvents
	DoEvents
	sv.ScrollPosition = top
	DoEvents
End Sub

Private Sub Panel_Click
	If SubExists(CallBack, EventName & "_ItemClick") Then
		Dim v As View
		v = Sender
		CallSub3(CallBack, EventName & "_ItemClick", v.Tag, items.Get(v.Tag))
	End If
End Sub
Private Sub Panel_LongClick
	If SubExists(CallBack, EventName & "_LongClick") Then
		Dim v As View
		v = Sender
		CallSub3(CallBack, EventName & "_LongClick", v.Tag, items.Get(v.Tag))
	End If
End Sub

'Returns the index of the item that holds the given view.
Public Sub GetItemFromView(v As View)
	Dim r As Reflector
	Dim parent, current As Object
	parent = v
	Do While (parent Is Panel) = False OR sv.Panel <> parent
		current = parent
		r.Target = current
		parent = r.RunMethod("getParent")
	Loop
	v = current
	Return v.Tag
End Sub
Public Sub SetVisible (Value As Boolean)
	sv.Visible = Value
	Visible = Value
End Sub
Public Sub SetBringToFront
	sv.BringToFront
End Sub

'Updates a custom item at the specified index.
Public Sub UpdateAt(Index As Int, Pnl As Panel, ItemHeight As Int, Value As Object)    
    
    Dim removePanel, p As Panel
    removePanel = panels.Get(Index)
    items.RemoveAt(Index)
    panels.RemoveAt(Index)
    removePanel.RemoveView
    
    
    Dim sd As StateListDrawable
    sd.Initialize
    sd.AddState(sd.State_Pressed, pressedDrawable)
    sd.AddCatchAllState(Pnl.Background)
    
    'create another panel to handle the click event
    Dim p As Panel
    p.Initialize("panel")
    p.Background = sd
    Dim cd As ColorDrawable
    cd.Initialize(Colors.Transparent, 0)
    Pnl.Background = cd
    p.AddView(Pnl, 0, 0, sv.Width, ItemHeight)
    p.Tag = Index    

    Dim top As Int
    If Index = 0 Then
        top = dividerHeight
    Else
        Dim previousPanel As Panel
        previousPanel = panels.Get(Index - 1)
        top = previousPanel.top + previousPanel.Height + dividerHeight
    End If

    items.InsertAt(Index, Value)
    panels.InsertAt(Index, p)
    sv.Panel.AddView(p, 0, top, sv.Width, ItemHeight)

End Sub
